import maya.cmds as cmds
import random
import math
import operator
import sys

sys.path.append('./')
import robot_brain as brain
reload(brain)

target = "Turret:aimpoint"
gi_source = "GiJoe:GIJoe"
gun = "Turret:gun"
GIs = []
IK = "Turret:TurrentIK"

class GunRobot():
	
	def __init__(self):
		self.hasTarget = False
		self.tarID = -1
		self.aimX = cmds.getAttr(target+".translateX")
		self.aimY = cmds.getAttr(target+".translateY")
		self.aimZ = cmds.getAttr(target+".translateZ")
		self.fire = False
		self.fireCyc = 0 
		self.recoil = 0.
	
	def think(self):
		speeds = []
		dists = []
		
		if(len(GIs) == 0):
			IKy = (1-cmds.getAttr(IK+".translateY"))*0.1
			if(cmds.getAttr(IK+".translateY") < 1 and IKy < 0):
				IKy = 0 
			cmds.move(-cmds.getAttr(IK+".translateX")*0.1,IKy,-cmds.getAttr(IK+".translateZ")*0.1, IK, r=1, )
			cmds.select(IK)
			cmds.setKeyframe()
			if(self.fire == True):
				cmds.select(gun)
				self.fireCyc += 0.2
				cmds.setKeyframe(v=self.fireCyc, at='firecyc')
				if(self.fireCyc >= 1):
					cmds.fire = False
			else:
				self.fireCyc = 0	
				cmds.setKeyframe(v=self.fireCyc, at='firecyc')
			return
		
		if(robot.hasTarget == False):
			for GI in GIs:
				if(GI.isAlive == True):
					print True
					dists.append( math.sqrt( math.pow(GI.x,2) + math.pow(GI.z,2) ) )
			self.tarID, min_dist = min(enumerate(dists), key=operator.itemgetter(1))
			self.hasTarget = True
			
		else:
			tarX = cmds.getAttr(GIs[self.tarID].obj+".translateX")
			tarZ = cmds.getAttr(GIs[self.tarID].obj+".translateZ")
			
			aimDist = 0.2
			if((tarX - self.aimX < aimDist and tarX - self.aimX > -aimDist ) and (tarZ - self.aimZ < aimDist and tarZ - self.aimZ > -aimDist )):
				self.recoil+=1.
				self.fire = True
				self.fireCyc = 0.4
				GIs[self.tarID].doDie()
				self.hasTarget = False
				GIs.pop(self.tarID)
				self.tarID = -1
			
			if(self.fire == True):
				cmds.select(gun)
				self.fireCyc += 0.2
				cmds.setKeyframe(v=self.fireCyc, at='firecyc')
				if(self.fireCyc >= 1):
					cmds.fire = False
			else:
				self.fireCyc = 0	
				cmds.setKeyframe(v=self.fireCyc, at='firecyc')
			
			
			if(self.recoil > 0.2):
				cmds.move(self.recoil,self.recoil,0.5-random.random(), IK, r=1, )
				self.recoil = self.recoil * 0.6
			
			IKy = (2-cmds.getAttr(IK+".translateY"))*0.1
			if(cmds.getAttr(IK+".translateY") < 1 and IKy < 0.1):
				IKy = 0
			cmds.move(-cmds.getAttr(IK+".translateX")*0.1,IKy,-cmds.getAttr(IK+".translateZ")*0.1, IK, r=1, )
			cmds.select(IK)
			cmds.setKeyframe()
			
			self.aimX += (tarX - self.aimX) * 0.2
			self.aimY += (-1 - self.aimY) * 0.2
			self.aimZ += (tarZ - self.aimZ) * 0.2
			
		cmds.select(target)
		cmds.setAttr(target+".translateX",self.aimX)
		cmds.setAttr(target+".translateY",self.aimY)
		cmds.setAttr(target+".translateZ",self.aimZ)
		cmds.setKeyframe()
		
		
		#for GI in GIs:
		#	speeds.append(GI.wait)
		#max_speed_index, max_speed = max(enumerate(speeds), key=operator.itemgetter(1))
		
		

robot = GunRobot()
def clear():
	cmds.cutKey(target,time=(0,10000),option="keys")
	cmds.cutKey(gun,time=(0,10000),option="keys")
	cmds.cutKey(IK,time=(0,10000),option="keys")
	cmds.select(gun)
	cmds.setKeyframe(v=0, at='firecyc')
	cmds.setAttr(target+".translateZ",0)
	cmds.setAttr(target+".translateY",0)
	cmds.setAttr(target+".translateX",-6)
	cmds.currentTime(1)
	cmds.select(all=1)
	cmds.delete()
	
	#cmds.rigidSolver("Turret:rigidSolver", e=1, cd=1, deleteCache=1)

def build(GICount):
	print "Reseting Scene..."
	clear()
	
	print "Building...GIs"
	
	d = 10
	gi_spacing = .5
	
	for i in range (GICount):
		t = random.random()*(math.radians(160))+math.radians(100);
		x = (d+(i/5)) * math.cos(t);
		z = (d+(i/5)) * math.sin(t);

		ignore = False
		
		for GI in GIs:
			if(GI.compare(x, z, gi_spacing) == 0):
				ignore = True
				break
		
		if(ignore == True):
			print "ignored "+str(i)
		else:
			cmds.select(gi_source)
			gi_tmp = cmds.duplicate(n="GI_"+str(i))[0]
			cmds.setAttr(gi_tmp+".translateZ",z)
			cmds.setAttr(gi_tmp+".translateX",x)
			GIs.append(brain.GI(gi_tmp))
	
	
def run(nframes):
	print "Running..."
	cmds.playbackOptions(min=1,max=nframes)
	for iframe in range(nframes):
		cmds.currentTime(iframe)
		for GI in GIs:
			GI.live()
		robot.think()
	print "Done!"
