import maya.cmds as cmds
import math
import random

floor = "Turret:floor"
gravity = "Turret:gravity"

class GI():
	
	def __init__(self,obj):
		self.wait = random.randint(0,20)
		self.cycleState = 0
		self.cycleMode = 0
		self.isAlive = True
		self.waited = random.randint(0,5)
		self.obj = obj
		self.dobj = ""
		self.boost = 0.05+(random.random()*0.2)
		self.liveRate = (self.boost+(random.random()*0.08-0.025))
		self.x = cmds.getAttr(self.obj+".translateX")
		self.z = cmds.getAttr(self.obj+".translateZ")
		self.r = cmds.getAttr(self.obj+".rotateY")

	def compare(self,x,z,dist):
		if(x>self.x-dist and x<self.x+dist):
				return 0
		if(z>self.z-dist and z<self.z+dist):
			return 0
		return 1
	
	def live(self):
		self.waited += 1
		
		if (self.waited > self.wait or self.cycleState > 0):
			
			rTarget = math.degrees(math.atan2(self.x,self.z))
			
			if(self.cycleMode == 0):
				self.r += 3 + (rTarget-self.r)*0.01
			else:
				self.r += -3 + (rTarget-self.r)*0.01
			
			self.x += -math.sin(math.radians(rTarget*0.9))* self.liveRate/2
			self.z += -math.cos(math.radians(rTarget*0.9))* self.liveRate/2

			
			self.waited = 0
			self.cycleState += 1
			if (self.cycleState > self.wait):
				self.cycleState = 0
				if(self.cycleMode == 0): self.cycleMode = 1
				else: self.cycleMode = 0
				self.liveRate = (self.boost+(random.random()*0.08-0.025))
			
		cmds.select(self.obj)
		cmds.setAttr(self.obj+".rotateY",self.r)
		cmds.setAttr(self.obj+".translateX",self.x)
		cmds.setAttr(self.obj+".translateZ",self.z)
		cmds.setKeyframe()
		
	def doDie(self):
		self.isAlive = False
		print self.obj+" is dying"
		
		cmds.select(self.obj)
		self.dobj = cmds.duplicate(n=self.obj+"_phys")[0]
		
		cmds.select(self.obj)
		cmds.setAttr(self.obj+".visibility",0)
		cmds.setKeyframe()
		
		cmds.select(self.dobj)
		curFrame = cmds.currentTime(query=1)
		cmds.currentTime(curFrame-1)
		cmds.setKeyframe(v=0, at='visibility')
		cmds.currentTime(curFrame)
		cmds.setKeyframe(v=1, at='visibility')
		
		rTarget = math.degrees(math.atan2(self.x,self.z))
		vX = math.sin(math.radians(rTarget*0.9))*(10+random.randint(0,10))
		vZ = math.cos(math.radians(rTarget*0.9))*(10+random.randint(0,10))
		
		cmds.rigidBody( active=True, iav=(-vX, vZ, vZ), b=0.01, sf=0.4, m=2 )
		cmds.connectDynamic(self.dobj,f=gravity)
		
		
		
		
		